<?php
/**********************************************************************
***********************************************************************/
//------------------- update average material cost ------------------------------------------ Joe Hunt Mar-03-2008


function update_average_material_cost($supplier, $stock_id, $price, $qty, $date, $adj_only=false, &$price_in_home_currency = 0)
{
	// probably this function should be optimized
	// passing transaction cart as argument. This would
	// save a couple of db calls like get_supplier()
	
	$supp = get_supplier($supplier);
	if ($supplier != null){
            $currency = $supp['curr_code'];
        }else{
            $currency = null;
        }

	if (isset($supp['tax_included']) && $supp['tax_included'] == 1){
		$price = get_tax_free_price_for_item($stock_id, $price, $supp['tax_group_id'], $supp['tax_included']);
        }

	if ($currency != null)
	{
		$ex_rate = get_exchange_rate_to_home_currency($currency, $date);
		$price_in_home_currency = $price / $ex_rate;
	}	
	else{
		$price_in_home_currency = $price;
    }
	
	$price_in_home_currency_ = $price_in_home_currency;

	//Handle if inventory will become negative
    //8-OCT-2011 : Skip negative inventory adjustment for case of adjust_only
    if (is_inventory_item($stock_id) && !$adj_only){ 
        handle_negative_inventory($stock_id, $qty, $price_in_home_currency, $date);
    }
	
	$sql = "SELECT mb_flag, material_cost, labour_cost, overhead_cost FROM ".TB_PREF."stock_master WHERE stock_id=".db_escape($stock_id);
	$result = db_query($sql);
	$myrow = db_fetch($result);
	$material_cost = $myrow['material_cost'];
	
	//Price adjustment for manufactured item
	if (!$adj_only && $myrow['mb_flag'] == 'M') 
	{
		$standard_cost = get_standard_cost($stock_id);
		//reduce overhead_cost and labour_cost from price as those will remain as is
		$price_in_home_currency = $price_in_home_currency - $myrow['labour_cost'] - $myrow['overhead_cost'];
	}
	
	if ($adj_only)
		$exclude = ST_CUSTDELIVERY;
	else
		$exclude = 0;
	$cost_adjust = false;
	$qoh = get_qoh_on_date($stock_id);

	if ($adj_only)
	{
		if ($qoh > 0){
			$material_cost = ($qoh * $material_cost + $qty * $price_in_home_currency) /	$qoh;
        }
	}
	else
	{
		if ($qoh < 0)
		{
			if ($qoh + $qty >= 0)
				$cost_adjust = true;
			$qoh = 0;
		}
		if ($qoh + $qty > 0){
			$material_cost = ($qoh * $material_cost + $qty * $price_in_home_currency) /	($qoh + $qty);
        }
	}

	if ($cost_adjust) // new 2010-02-10 //Chaitanya : Material_cost replaced with price
		adjust_deliveries($stock_id, $price_in_home_currency_, $date);
        
        $material_cost = $material_cost > 0 ? $material_cost : 0;
        
	$sql = "UPDATE ".TB_PREF."stock_master SET material_cost=".db_escape($material_cost)."
		WHERE stock_id=".db_escape($stock_id);

	db_query($sql,"The cost details for the inventory item could not be updated");
	return $material_cost;
}

//-------------------------------------------------------------------------------------------------------------

function add_grn(&$po)
{
	global $Refs, $SysPrefs;

	$date_ = $po->orig_order_date;

	begin_transaction();
	hook_db_prewrite($po, ST_SUPPRECEIVE);
        
        
        // Make sure no one has updated the PO
        $n1 = update_po_header_row_state($po->order_no, $po->row_state);
        if($n1 != 1){
                cancel_transaction();
                display_error("Another user has updated this PO. Please select another PO.");
                return 0;
        }  
        
        if($po->receiving_pr_no > 0){
            // Make sure no one has updated the PR
//            $n1 = update_pr_header_row_state($po->receiving_pr_no, $po->pr_row_state);
            $created_by = $_SESSION['wa_current_user']->user;
            $uprs_msg = update_pr_status($po->receiving_pr_no, AS_ISSUED, $po->pr_row_state, $created_by);
            if($uprs_msg['success'] !== true)
            {
                cancel_transaction();
//                return array("passed" => false, "tran_no" => $source_pr_no, "message" => $uprs_msg['message']);
                display_error($uprs_msg['message']);
                return 0;
            } 
        }

	add_new_exchange_rate(get_supplier_currency($po->supplier_id), $date_, $po->ex_rate);

	$grn = add_grn_batch($po->order_no, $po->supplier_id, $po->reference, $po->Location, $date_, $po->receiving_pr_no, $po->project_id);

        $clearing_act = get_company_pref('grn_clearing_act');
	if ($clearing_act) {	// otherwise GRN clearing account is not used
	    $total = 0;
	}
	foreach ($po->line_items as $line_no => $order_line)
	{
		if ($order_line->item_selected && $order_line->receive_qty != 0 && $order_line->receive_qty != "" && isset($order_line->receive_qty))
		{
                        
                        $unit_cost_in_home_currency = 0;
            
			$stock_gl_code = get_stock_gl_code($order_line->stock_id);

			/*Update sales_order_details for the new quantity received and the standard cost used for postings to GL and recorded in the stock movements for FIFO/LIFO stocks valuations*/
			//------------------- update average material cost and clearing account ----- Joe Hunt Mar-03-2008
                        $inventory_item = is_inventory_item($order_line->stock_id);
			if ($inventory_item)
			{
				if ($clearing_act){
//					$total += add_gl_trans_supplier(ST_SUPPRECEIVE, $grn, $date_, $stock_gl_code["inventory_account"],
//						$stock_gl_code['dimension_id'], $stock_gl_code['dimension2_id'],
//						$order_line->receive_qty * $order_line->taxfree_charge_price($po), $po->supplier_id, '', 0, $order_line->stock_id);
                                }
				update_average_material_cost($po->supplier_id, $order_line->stock_id, $order_line->price,
					$order_line->receive_qty, $date_, false, $unit_cost_in_home_currency);
			}
                        else{
                                $supp = get_supplier($po->supplier_id);
                                $unit_cost_in_home_currency = get_tax_free_price_for_item($order_line->stock_id, $order_line->price, $supp['tax_group_id'], $supp['tax_included']);
                        }
			//----------------------------------------------------------------------------------------------------------------
//			if ($order_line->qty_received == 0)
			{
				/*This must be the first receipt of goods against this line */
			   	/*Need to get the standard cost as it is now so we can process GL jorunals later*/
			   	$order_line->standard_cost = get_standard_cost($order_line->stock_id);
			}
			// added 2008-12-08 Joe Hunt. Update the purchase data table
			add_or_update_purchase_data($po->supplier_id, $order_line->stock_id, $order_line->price, 
				$order_line->item_description, $po->project_id, $po->task_id); 

			/*Need to insert a grn item */ // also need to check for over-receive.(within allowance)
//			if ($order_line->receive_qty + $order_line->qty_received > $order_line->quantity){
//				$order_line->quantity = $order_line->receive_qty + $order_line->qty_received;
//            }
            
            
			$grn_item = add_grn_detail_item($grn, $order_line->po_detail_rec,
				$order_line->stock_id, $order_line->item_description,
				$order_line->standard_cost,	$order_line->receive_qty, $unit_cost_in_home_currency, $order_line->quantity,
                                $order_line->tran_unit, $order_line->tran_qty, $order_line->convertion_factor,
                                $order_line->project_site_id, $order_line->tran_qty);

			$po->line_items[$line_no]->grn_item_id = $grn_item;
                        
			/* Update location stock records - NB  a po cannot be entered for a service/kit parts done automatically */
            
            // Create stock movement entries only if the item is an inventory item - Nalin
                        if($inventory_item){
                                add_stock_move(ST_SUPPRECEIVE, $order_line->stock_id, $grn, $po->Location, 
                                                $date_, "", $order_line->receive_qty, $order_line->standard_cost,
                                                $po->supplier_id, 1, $order_line->taxfree_charge_price($po),null, 
                                                null, $order_line->tran_unit, $order_line->tran_qty, $order_line->convertion_factor,
                                                0, $order_line->project_site_id, $order_line->po_detail_rec, $po->project_id);


                                $ailqdm_msg =  add_item_line_quantity_detail_movements(ST_SUPPRECEIVE, $grn, $po->Location, 
                                                                                            $date_, $order_line, true, $reference = '');
                                if($ailqdm_msg['success'] !== true){
                                    cancel_transaction();
                                    display_error($ailqdm_msg['message']);
                                    return 0;
                                }  
                        }else{
                            add_non_stock_move(ST_SUPPRECEIVE, $order_line->stock_id, $grn, $po->Location, $date_, $po->reference, 
                                    $order_line->receive_qty, $order_line->standard_cost, $po->supplier_id, 1, 
                                    $unit_cost_in_home_currency, 0, $order_line->tran_unit, $order_line->tran_qty, $order_line->convertion_factor, 
                                    0, $order_line->project_site_id, $order_line->po_detail_rec, $order_line->item_description, $po->project_id);
                        }

		} /*quantity received is != 0 */
	} /*end of order_line loop */

	if ($clearing_act && $total != 0.0) {
//		$total += add_gl_trans_supplier(ST_SUPPRECEIVE, $grn, $date_, $clearing_act,
//			0, 0, -$total, null);
	}
	$Refs->save(ST_SUPPRECEIVE, $grn, $po->reference);

	add_audit_trail(ST_SUPPRECEIVE, $grn, $date_);

	$po->trans_no = $grn;
	hook_db_postwrite($po, ST_SUPPRECEIVE);
	commit_transaction();

	return $grn;
}

//----------------------------------------------------------------------------------------

function add_grn_batch($po_number, $supplier_id, $reference, $location, $date_, $pr_no=0, $project_id=0)
{
	$date = date2sql($date_);
    
    $created_by = $_SESSION['wa_current_user']->user;
	$created_on = date('Y-m-d H:i:s');

	$sql = "INSERT INTO ".TB_PREF."grn_batch (
                    purch_order_no, delivery_date, 
                    supplier_id, reference, 
                    loc_code, pr_no,
                    project_id,
                    created_by, created_on)
			VALUES (".db_escape($po_number).", ".db_escape($date).", "
                    .db_escape($supplier_id).", ".db_escape($reference).", "
                    .db_escape($location).", ".db_escape($pr_no).", "
                    .db_escape($project_id).", "
                    .db_escape($created_by).", ".db_escape($created_on).")";

	db_query($sql, "A grn batch record could not be inserted.");

	return db_insert_id();
}

//-------------------------------------------------------------------------------------------------------------

function add_grn_detail_item($grn_batch_id, $po_detail_item, $item_code, $description, $standard_unit_cost,
                $quantity_received, $unit_cost_in_home_currency, $quantity,
                $tran_unit, $tran_qty, $receive_unit_conv_factor,
                $project_site_id, $original_tran_qty=0)
{
//	$sql = "UPDATE ".TB_PREF."purch_order_details
//        SET quantity_received = quantity_received + ".db_escape($quantity_received).",
//        std_cost_unit=".db_escape($standard_unit_cost).",
//        quantity_ordered=".db_escape($quantity).",
//        act_price=".db_escape($price)."
//        WHERE po_detail_item = ".db_escape($po_detail_item);
    
        

	$sql = "INSERT INTO ".TB_PREF."grn_items (grn_batch_id, po_detail_item, 
                        item_code, description, qty_recd,
                        tran_unit, tran_qty, convertion_factor,
                        project_site_id, unit_cost,
                        original_tran_qty)
		VALUES (".db_escape($grn_batch_id).", ".db_escape($po_detail_item).", "
                .db_escape($item_code).", ".db_escape($description).", ".db_escape($quantity_received).","
                .db_escape($tran_unit).", ".db_escape($tran_qty).", ".db_escape($receive_unit_conv_factor).","
                .db_escape($project_site_id).", ".db_escape($unit_cost_in_home_currency).", "
                .db_escape($original_tran_qty).")";

	db_query($sql, "A GRN detail item could not be inserted.");
        
        $grn_item = db_insert_id();
        
        $po_item_total_received_qty = get_po_item_total_received_qty($po_detail_item);
        
        $sql = "UPDATE ".TB_PREF."purch_order_details
                SET quantity_received = ".db_escape($po_item_total_received_qty)." 
                WHERE po_detail_item = ".db_escape($po_detail_item);

	db_query($sql, "a purchase order details record could not be updated. This receipt of goods has not been processed ");

	return $grn_item;
}

//----------------------------------------------------------------------------------------
function get_grn_batch_from_item($item)
{
	$sql = "SELECT grn_batch_id FROM ".TB_PREF."grn_items WHERE id=".db_escape($item);
	$result = db_query($sql, "Could not retreive GRN batch id");
	$row = db_fetch_row($result);
	return $row[0];
}


function get_grn_batch($grn)
{
	$sql = "SELECT * FROM ".TB_PREF."grn_batch WHERE id=".db_escape($grn);
	$result = db_query($sql, "Could not retreive GRN batch id");
	return db_fetch($result);
}

function set_grn_item_credited(&$entered_grn, $supplier, $transno, $date, $project_site_id = 0)
{
    $inventory_item = is_inventory_item($entered_grn->item_code);
    if($inventory_item){
	$mcost = update_average_material_cost($supplier, $entered_grn->item_code,
                                            $entered_grn->chg_price, $entered_grn->this_quantity_inv, $date);
    }

 	$sql = "SELECT grn_batch.*,
                    grn_items.* 
            FROM ".TB_PREF."grn_batch grn_batch, "
                    .TB_PREF."grn_items grn_items 
            WHERE grn_items.grn_batch_id = grn_batch.id
                    AND grn_items.id = ".db_escape($entered_grn->id)."
                    AND grn_items.item_code=".db_escape($entered_grn->item_code);
    
	$result = db_query($sql, "Could not retreive GRNS");
	$myrow = db_fetch($result);

//	$sql = "UPDATE ".TB_PREF."purch_order_details
//            SET quantity_received = quantity_received + ".db_escape($entered_grn->this_quantity_inv).",
//                    quantity_ordered = quantity_ordered + ".db_escape($entered_grn->this_quantity_inv).",
//                    qty_invoiced = qty_invoiced + ".db_escape($entered_grn->this_quantity_inv).",
//                    std_cost_unit=".db_escape($mcost).",
//                    act_price=".db_escape($entered_grn->chg_price)."
//            WHERE po_detail_item = ".$myrow["po_detail_item"];

	$sql = "UPDATE ".TB_PREF."purch_order_details
            SET quantity_received = quantity_received + ".db_escape($entered_grn->this_quantity_inv).",
                    qty_invoiced = qty_invoiced + ".db_escape($entered_grn->this_quantity_inv)." 
            WHERE po_detail_item = ".$myrow["po_detail_item"];
    
	db_query($sql, "a purchase order details record could not be updated. This receipt of goods has not been processed ");

	//$sql = "UPDATE ".TB_PREF."grn_items SET qty_recd=0, quantity_inv=0 WHERE id=$entered_grn->id";
	$sql = "UPDATE ".TB_PREF."grn_items 
            SET qty_recd = qty_recd + ".db_escape($entered_grn->this_quantity_inv).",
                    quantity_inv = quantity_inv + ".db_escape($entered_grn->this_quantity_inv).", 
                    tran_qty = tran_qty + ".db_escape($entered_grn->this_quantity_inv * $myrow['convertion_factor'])." 
            WHERE id=".db_escape($entered_grn->id);
	
    db_query($sql);

    if($inventory_item){
        add_stock_move(ST_SUPPCREDIT, $entered_grn->item_code, $transno, $myrow['loc_code'], $date, "",
                        $entered_grn->this_quantity_inv, $mcost, $supplier, 1, $entered_grn->chg_price,
                        0, "", $entered_grn->po_unit, $entered_grn->this_quantity_inv_po_unit, $entered_grn->po_unit_conv_factor,
                        0, $project_site_id, $entered_grn->id, $myrow['project_id']);
        
    }else{
        add_non_stock_move(ST_SUPPCREDIT, $entered_grn->item_code, $transno, $myrow['loc_code'], $date, '', 
                        $entered_grn->this_quantity_inv, $entered_grn->chg_price, $supplier, 1, 
                        $entered_grn->chg_price, 0, $entered_grn->po_unit, $entered_grn->this_quantity_inv_po_unit, $entered_grn->po_unit_conv_factor, 
                        0, $project_site_id, $myrow['id'], $myrow['description'], $myrow['project_id']);
    }
}

function get_grn_items($grn_batch_id=0, $supplier_id="", $outstanding_only=false,
	$is_invoiced_only=false, $invoice_no=0, $begin="", $end="")
{
    $sql = "SELECT grn.*, 
                    grn_items.*, 
                    pod.unit_price,
                    pod.act_price,
                    pod.quantity_ordered,
                    pod.std_cost_unit, 
                    pod.order_unit po_order_unit,
                    pod.order_unit_qty po_order_unit_qty,
                    pod.order_unit_conv_factor po_order_unit_conv_factor,
                    pod.order_unit_price po_order_unit_price,
                    pod.order_unit_price_discount po_order_unit_price_discount,

                    sm.units
            FROM ".TB_PREF."grn_batch grn,
                    ".TB_PREF."grn_items grn_items, 
                    ".TB_PREF."purch_order_details pod, 
                    ".TB_PREF."stock_master sm";
    
            if ($invoice_no != 0){
                $sql .= ", ".TB_PREF."supp_invoice_items suppii";
            }
    
            $sql .= " WHERE grn_items.grn_batch_id=grn.id
                        AND grn_items.po_detail_item = pod.po_detail_item";
	
            if ($invoice_no != 0){
                $sql .= " AND suppii.supp_trans_type = ".ST_SUPPINVOICE." 
                            AND suppii.supp_trans_no = $invoice_no 
                            AND grn_items.id = suppii.grn_item_id";
            }
	
            $sql .= " AND sm.stock_id=grn_items.item_code ";

            if ($begin != ""){
                $sql .= " AND grn.delivery_date>='".date2sql($begin)."'";
            }
            
            if ($end != ""){
                $sql .= " AND grn.delivery_date<='".date2sql($end)."'";
            }
            
            if ($grn_batch_id != 0){
                $sql .= " AND grn.id=".db_escape($grn_batch_id)." AND grn_items.grn_batch_id=".db_escape($grn_batch_id);
            }

            if ($is_invoiced_only){
                $sql .= " AND grn_items.quantity_inv > 0";
            }

            if ($outstanding_only){
                $sql .= " AND grn_items.qty_recd - grn_items.quantity_inv > 0";
            }

            if ($supplier_id != ""){
                $sql .= " AND grn.supplier_id =".db_escape($supplier_id);
            }

            $sql .= " ORDER BY grn.delivery_date, grn.id, grn_items.id";

	return db_query($sql, "Could not retreive GRNS");
}

//----------------------------------------------------------------------------------------

// get the details for a given grn item

function get_grn_item_detail($grn_item_no)
{
	$sql = "SELECT grn_items.*, 
                    pod.unit_price,
                    grn_items.qty_recd - grn_items.quantity_inv AS QtyOstdg,
                    pod.std_cost_unit,
                    pod.act_price,
                    pod.quantity_ordered,
                    pod.order_unit po_order_unit,
                    pod.order_unit_qty po_order_unit_qty,
                    pod.order_unit_conv_factor po_order_unit_conv_factor,
                    pod.order_unit_price po_order_unit_price,
                    pod.order_unit_price_discount po_order_unit_price_discount 
            FROM ".TB_PREF."grn_items grn_items, 
                    ".TB_PREF."purch_order_details pod, 
                    ".TB_PREF."stock_master sm 
            WHERE grn_items.po_detail_item = pod.po_detail_item
                    AND sm.stock_id = grn_items.item_code
                    AND grn_items.id=".db_escape($grn_item_no);

	$result = db_query($sql, "could not retreive grn item details");
	return db_fetch($result);
}

//----------------------------------------------------------------------------------------

function get_grn_item($grn_item_no)
{
	$sql = "SELECT grn_items.* 
		FROM ".TB_PREF."grn_items grn_items, 
                ".TB_PREF."stock_master sm 
		WHERE sm.stock_id = grn_items.item_code
			AND grn_items.id=".db_escape($grn_item_no);

	$result = db_query($sql, "could not retreive grn item");
	return db_fetch($result);
}

//----------------------------------------------------------------------------------------


function read_grn_items_to_order($grn_batch, &$order)
{
	$result = get_grn_items($grn_batch);

  	if (db_num_rows($result) > 0)
  	{

	 	while ($myrow = db_fetch($result))
	 	{
                        if ($myrow['qty_recd'] == 0 && $myrow['quantity_inv'] == 0){
                            if ($myrow['original_tran_qty'] > 0){
                                $myrow['qty_recd'] = $myrow['original_tran_qty'] * $myrow["convertion_factor"];
                                $myrow['tran_qty'] = $myrow['original_tran_qty'] * $myrow["convertion_factor"];
                            }
                        }
                            
	 		if ($myrow['qty_recd'] == 0 && $myrow['quantity_inv'] == 0){
				continue; // 2011-01-18 Joe Hunt. We will not have empty credited rows.
                        }
		 	if (is_null($myrow["units"]))
		 	{
				$units = "";
		 	}
		 	else
		 	{
				$units = $myrow["units"];
		 	}

			$order->add_to_order($order->lines_on_order, $myrow["item_code"],
				$myrow["qty_recd"],$myrow["description"], $myrow["unit_price"],$units,
				sql2date($myrow["delivery_date"]), $myrow["quantity_inv"],
				$myrow["qty_recd"], 0, 0, 0,  $myrow["tran_unit"], $myrow["tran_qty"], $myrow["convertion_factor"],
                                0, 0, 0, $myrow['original_tran_qty']);                        

			$order->line_items[$order->lines_on_order-1]->po_detail_rec = $myrow["po_detail_item"];
                        $order->line_items[$order->lines_on_order-1]->order_unit_price = $myrow["po_order_unit_price"];
                        $order->line_items[$order->lines_on_order-1]->order_unit_price_discount = $myrow["po_order_unit_price_discount"];
                        $order->line_items[$order->lines_on_order-1]->grn_item_id = $myrow["id"];
            
		} /* line po from purchase order details */
  	} //end of checks on returned data set
}

//----------------------------------------------------------------------------------------

// read a grn into an order class

function read_grn($grn_batch, &$order)
{
	$sql= "SELECT *	FROM ".TB_PREF."grn_batch WHERE id=".db_escape($grn_batch);

	$result = db_query($sql, "The grn sent is not valid");

	$row = db_fetch($result);
	$po_number = $row["purch_order_no"];

	$result = read_po_header($po_number, $order);

	if ($result)
	{

		$order->trans_type = ST_SUPPRECEIVE;
		$order->orig_order_date = sql2date($row["delivery_date"]);
		$order->Location = $row["loc_code"];
		$order->reference = $row["reference"];

		read_grn_items_to_order($grn_batch, $order);
	}
}

//----------------------------------------------------------------------------------------------------------

// get the GRNs (batch info not details) for a given po number

function get_po_grns($po_number)
{
    $sql = "SELECT * FROM ".TB_PREF."grn_batch WHERE purch_order_no=".db_escape($po_number);

	return db_query($sql, "The grns for the po $po_number could not be retreived");
}

//----------------------------------------------------------------------------------------------------------

function exists_grn($grn_batch)
{
	$sql = "SELECT id FROM ".TB_PREF."grn_batch WHERE id=".db_escape($grn_batch);
	$result = db_query($sql, "Cannot retreive a grn");

    return (db_num_rows($result) > 0);
}

//----------------------------------------------------------------------------------------------------------

function exists_grn_on_invoices($grn_batch)
{
	$sql = "SELECT ".TB_PREF."supp_invoice_items.id FROM ".TB_PREF."supp_invoice_items,".TB_PREF."grn_items
		WHERE ".TB_PREF."supp_invoice_items.grn_item_id=".TB_PREF."grn_items.id
		AND quantity != 0
		AND grn_batch_id=".db_escape($grn_batch);
	$result = db_query($sql, "Cannot query GRNs");

    return (db_num_rows($result) > 0);
}

//----------------------------------------------------------------------------------------------------------

function void_grn($grn_batch)
{
	// if this grn is references on any invoices/credit notes, then it
	// can't be voided
	if (exists_grn_on_invoices($grn_batch))
		return false;

	begin_transaction();
	hook_db_prevoid(ST_SUPPRECEIVE, $grn_batch);

	void_bank_trans(ST_SUPPRECEIVE, $grn_batch, true);
	void_gl_trans(ST_SUPPRECEIVE, $grn_batch, true);

	// clear the quantities of the grn items in the POs and invoices
	$result = get_grn_items($grn_batch);

    if (db_num_rows($result) > 0)
    {

    	while ($myrow = db_fetch($result))
        {

        	$sql = "UPDATE ".TB_PREF."purch_order_details
                SET quantity_received = quantity_received - " . $myrow["qty_recd"] . "
                WHERE po_detail_item = " . $myrow["po_detail_item"];

        	db_query($sql, "a purchase order details record could not be voided.");
        }
    }

	// clear the quantities in the grn items
	$sql = "UPDATE ".TB_PREF."grn_items SET qty_recd=0, quantity_inv=0
		WHERE grn_batch_id=".db_escape($grn_batch);

	db_query($sql, "A grn detail item could not be voided.");

    // clear the stock move items
    void_stock_move(ST_SUPPRECEIVE, $grn_batch);

	commit_transaction();

	return true;
}


function get_outstanding_direct_purchase_requisitions_for_po($po_no)
{
    $user_id = $_SESSION['wa_current_user']->user;
    
    $sql = "SELECT vopr.*,
                    pm.description project_description,
                    l.location_name,
                    u.real_name 
            FROM ".TB_PREF."vw_outstanding_purchase_requisitions vopr,
                    ".TB_PREF."locations l,
                    ".TB_PREF."projects_master pm,
                    ".TB_PREF."user_data_access_groups as udag,
                    ".TB_PREF."users u 
            WHERE po_no = ".db_escape($po_no)." AND 
                    vopr.location = l.loc_code AND 
                    vopr.project_id = pm.project_id AND 
                    pm.dag_id = udag.dag_id AND 
                    udag.user_id = ".db_escape($user_id)." AND 
                    vopr.created_by = u.id 
            ORDER BY vopr.pr_no";
	
    return db_query($sql, "Could not get_outstanding_direct_purchase_requisitions_for_po");

}

function get_grn_max_unit_price($item_code, $description)
{

    $sql = "SELECT id, grn_batch_id, unit_cost 
            FROM ".TB_PREF."grn_items 
            WHERE item_code = ".db_escape($item_code)." AND 
                    description = ".db_escape($description)."  
            ORDER BY unit_cost DESC  
            LIMIT 1 ";
	
    $result = db_query($sql, "get_grn_max_unit_price");
    
    return db_fetch($result);
}


function get_po_item_total_received_qty($po_line_id)
{
    $sql = "SELECT SUM(qty_recd) total_quantity_received  
            FROM ".TB_PREF."grn_items   
            WHERE po_detail_item = ".db_escape($po_line_id);
    
    $result = db_query($sql, "get_po_item_total_received_qty");
    return db_result_value($result, "total_quantity_received");
}